<?php
$explan = "アクセスの多い順にページ名を一覧表示
オプションは[[access(20)]]、[[access('nmb=20|sort=ascend')]]のように指定
<h3>指定できるオプション</h3>
<dl><dt>nmb</dt><dd>表示件数</dd></dl>
<dl><dt>sort</dt><dd>ascend:昇順　descend:降順</dd></dl>
<dl><dt>hide_count</dt><dd>アクセスカウントを表示しない　1:表示しない　0:表示する</dd></dl>
<dl><dt>hide_number</dt><dd>順位の数を表示しない　1:表示しない　0:表示する</dd></dl>
";
$format = "[[access]]	// 基本形
[[access(20)]]	// 表示件数を指定する場合
[[access('hide_count=1|hide_number=1|sort=ascend')]]	// カウント数と順位なしで、昇順に表示する場合
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function access($nmb = '', $access_sort = '') {
	global $admin_back_color, $admin_pass_name, $req;
	if (!preg_match('/^\d*$/', $nmb)) {
		$option = $nmb;
		$nmb = '';
	}
	if (isset($option) && $option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			if (preg_match('/^\d*$/', $_)) {
				$nmb = $_;
			} else {
				$tmp2 = explode('=',$_);
				if (isset($tmp2[0]) && isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
			}
		}
	} else { unset($option); }
	if (isset($option['nmb']) && preg_match('/^\d*$/', $option['nmb'])) { $nmb = $option['nmb']; }
	if (! isset($option['term_area'])) { $option['term_area'] = ''; }
	if (! isset($option['sort'])) { $option['sort'] = ''; }
	if (! isset($option['access_sort'])) { $option['access_sort'] = ''; }
	if (!$option['access_sort']) { $option['access_sort'] = $option['sort']; }
	if (! isset($option['hide_count'])) { $option['hide_count'] = ''; }
	if (! isset($option['hide_number'])) { $option['hide_number'] = ''; }
	$access_sort = $option['access_sort'];
	$logdir = './data/counter';
	if (!is_dir($logdir)) { return; }
	if (!$nmb) { $nmb = 10; }
	if (file_exists('./data/list/tm_sort_list.cgi')) {
		$tm_sort_list = file('./data/list/tm_sort_list.cgi',FILE_IGNORE_NEW_LINES);
		foreach ($tm_sort_list as $line) {
			$tmp = explode('<>',$line);
			if (isset($tmp[4])) { $admin_mode[$tmp[0]] = $tmp[4]; }
		}
	}
	if (!isset($_COOKIE[$admin_pass_name]) || !$_COOKIE[$admin_pass_name]) {
		$amode = 0;
	} else {
		$amode = 1;
	}
	$tmpdir = opendir($logdir);
	$log_list = array();
	$access = array();
	while ($file = readdir($tmpdir)) {
		if (preg_match('/(^[a-zA-Z0-9]+)\.cgi$/',$file,$matched)) {
			if (isset($admin_mode[$matched[1]]) && $admin_mode[$matched[1]] && !$amode) {
				continue;
			}
			$log_list[] = $file;
			$access[$matched[1]] = get_counter($matched[1]);
		}
	}
	closedir($tmpdir);
	if (!$access_sort || $access_sort == 'descend') {
		arsort($access);
		$access_sort = 'descend';
	} else {
		asort($access);
		$access_sort = 'ascend';
	}
	$str = '';
	$count = 0;
	$end = '';
	foreach ($access as $key=>$val) {
		if (!file_exists('./data/' . $key . '.cgi')) { continue; }
		if (!$val || ($access_sort == 'descend' && $end && $val < $end) || ($access_sort == 'ascend' && $end && $val > $end)) {
			break;
		}
		$class = 'list';
		list($log) = file('./data/' . $key . '.cgi');
		$tmp = explode('<>',$log);
		$hash = array('noform'=>$key);
		if ($req['sort']) { $hash['sort'] = $req['sort']; }
		$link = script_link($hash);
		list($name) = explode('&&',$tmp[2]);
		if ($option['hide_count']) {
			$show_count = '';
		} else {
			$show_count = '(' . number_format($val) . ')';
		}
		if ($amode && isset($admin_mode[$key]) && $admin_mode[$key]) {
			$class = 'amode';
		}
		if ($class) { $class = " class=\"$class\""; }
		$str .= "<li$class><a href=\"$link\">" . $name . "</a>$show_count</li>\n";
		$count++;
		if ($count >= $nmb) { $end = $val; }
	}
	if ($option['hide_number']) {
		if ($str) { $str = "<ol style=\"list-style-type:none;padding-left:0.5em;\">\n" . $str . "</ol>\n"; }
	} else {
		if ($str) { $str = "<ol style=\"padding-left:auto;\">\n" . $str . "</ol>\n"; }
	}
	return $str;
}
?>