<?php
$explan = 'bbsプラグインの最新投稿をチェックして、投稿数をカウント
<h3>指定できるオプション</h3>
<dl><dt>show_days</dt><dd>過去show_days日のコメントをカウントする
例　show_days=10</dd></dl>
<dl><dt>show_detail</dt><dd>詳細を表示する</dd></dl>
<dl><dt>sort</dt><dd>掲示板の表示順
sort=count(投稿の多い順) sort=newpost(最新の投稿時間順)</dd></dl>
';
$format = "[[bbs_count]]
[[bbs_count('show_detail=1|show_days=30')]]
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function bbs_count ($option = '') {
	global $datadir,$id,$script,$admin_back_color, $admin_pass_name;

	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			$option[$tmp2[0]] = $tmp2[1];
		}
	} else {
		unset($option);
	}
	if (!isset($option['show_days'])) { $option['show_days'] = 10; }	// カウントする日数
	if (!isset($option['show_detail'])) { $option['show_detail'] = 0; }	// 詳細を表示する
	if (!isset($option['sort'])) { $option['sort'] = 'newpost'; }			// 掲示板リストの表示順
	if (req('show_detail')) { $option['show_detail'] = req('show_detail'); }
	$html = '';
	$id = article_id();
	$list = $test = array();
	$tmpdir = opendir($datadir);
	while ($dir = readdir($tmpdir)) {
		if ($dir == '.' || $dir == '..') { continue; }
		if (is_dir($datadir . '/' . $dir) && file_exists($datadir . '/' . $dir . '.cgi') && file_exists($datadir . '/' . $dir . '/bbs/bbs.cgi')) {
			$list[] = $dir;
			$style = '';
			$line = file($datadir . '/' . $dir . '.cgi',FILE_IGNORE_NEW_LINES);
			$data = explode('<>',$line[0]);
			if (isset($data[7]) && $data[7]) {
				//$amode[$data[0]] = 1;
				if (isset($_COOKIE[$admin_pass_name]) && $_COOKIE[$admin_pass_name]) {
					$style = " style=\"background-color:$admin_back_color\"";
				} else {
					continue;
				}
			}
			$log = file($datadir . '/' . $dir . '/bbs/bbs.cgi');
			$art_title[$data[0]] = $data[2];
			foreach ($log as $line) {
				$tmp = explode('<>', $line);
				// 2022年06月07日(火) 18時04分 形式を 2022-06-07 18:04 形式に変更
				if (preg_match('/(\d{4})年(\d{2})月(\d{2})日\(?.+?\)? ?(\d{2})時(\d{2})分/', $tmp[1],$match)) {
					$tmp[1] = $match[1] . '-' . $match[2] . '-' . $match[3] . ' ' . $match[4] . ':' . $match[5] . ':00';
				// 2022/06/13(月) 10:52 形式にも対応
				} elseif (preg_match('/(\d{4})\/(\d{2})\/(\d{2})\(?.+?\)? ?(\d{2}):(\d{2})/', $tmp[1],$match)) {
					$tmp[1] = $match[1] . '-' . $match[2] . '-' . $match[3] . ' ' . $match[4] . ':' . $match[5] . ':00';
				}
				$date = new DateTime($tmp[1]);
				$epoc = $date->format('U');
				if (!isset($posttime[$dir]) || $epoc > $posttime[$dir]) {
					$posttime[$dir] = $epoc;
				}
				$test[] = time() - $epoc / (3600*24);
				if ((time() - $epoc) / (3600*24) < $option['show_days']) {
					if (!isset($art_count[$dir])) { $art_count[$dir] = 0; }
					$art_count[$dir]++;
				}
			}
		}
	}
	closedir($tmpdir);
	$hash = array('plugin'=>'bbs_count','show_detail'=>1);
	if (req('show_days')) { $hash['show_days'] = req('show_days'); }
	if (isset($art_count) && $art_count) {
		if ($option['sort'] == 'newpost') {
			arsort($posttime);
			$bbs_list = array_keys($posttime);
		} elseif ($option['sort'] == 'count') {
			arsort($art_count);
			$bbs_list = array_keys($art_count);
		}
		if ($option['show_detail']) {
			$hash = array('plugin'=>'bbs');
			foreach ($bbs_list as $key) {
				$hash['id'] = $key;
				$hash['noform'] = $key;
				if (isset($art_count[$key])) {
					$html .= "<div id=\"bbs_count\"><a href=\"" . script_link($hash,'bbs_count') . "#bbs\">" . $art_title[$key] . "($art_count[$key])</a></div>\n";
				}
			}
		} else {
			$total = 0;
			foreach ($art_count as $val) { $total += $val; }
			if (req('noform')) { $hash['noform'] = req('noform'); }
			$html .= "<div><a style=\"font-weight:bold;\" href=\"" . script_link($hash,'bbs_count') . "#bbs_count\">最近のコメント($total)</a></div>\n";
		}
	}
	return $html;
}
?>