<?php
$explan = "カテゴリーの一覧を表示する
<h3>指定できるオプション</h3>
<dl><dt>sort</dt><dd>ソート方法
sort=name(名前順) sort=new(新しい順) sort=nmb(記事の多い順)</dd></dl>
<dl><dt>hide_nocat</dt><dd>カテゴリーなしを隠す
hide_nocat=1(隠す) hide_nocat=0(隠さない)</dd></dl>
<dl><dt>cat_max</dt><dd>表示するカテゴリーの数
</dd></dl>
<dl><dt>style</dt><dd>リストに指定するstyle
例　style=padding:0.3em;
</dd></dl>
";	// プラグインの説明を記述
$format = "
[[categories]]			// 名前順に表示
[[categories('sort=nmb|cat_max=10')]]			// 記事が多い順に表示
[[categories('sort=new|hide_nocat=1')]]			// 記事が新しい順に表示
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function categories($option = '') {	//$ptn = '', $category = '', $sort = '', $type = '', $nmb = '', $length = ''
	global $show_new,$new_day,$current_time,$req,$admin_back_color,$listdir,$current_back_color, $admin_pass_name;
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[0]) && isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
		}
	} else {
		unset($option);
	}
	if (! isset($option['hide_nocat'])) { $option['hide_nocat'] = ''; }
//	if (! isset($option['ptn'])) { $option['ptn'] = ''; }
	if (! isset($option['sort'])) { $option['sort'] = ''; }
//	if (! isset($option['type'])) { $option['type'] = ''; }
//	if (! isset($option['nmb'])) { $option['nmb'] = ''; }
//	if (! isset($option['length'])) { $option['length'] = ''; }
	if (! isset($option['cat'])) { $option['cat'] = ''; }
	if (! isset($option['cat_max'])) { $option['cat_max'] = 40; }
	if (! isset($option['style'])) { $option['style'] = ''; }

	$category_list = array();	// カテゴリーに登録されている記事の数を調べるために使用(各記事のカテゴリーをすべて保存　重複も有り)
	$cat_belong = array();		// カテゴリー名をキーとする連想配列　カテゴリーが登録されている記事の数を値として保存
	if (!isset($_COOKIE[$admin_pass_name]) || !$_COOKIE[$admin_pass_name]) {
		$admin_mode = 0;
	} else {
		$admin_mode = 1;
	}
	if (!$admin_mode) {
		$category_file = join('/',array($listdir,'category_list.cgi'));		// カテゴリーリストを保存するファイルのパス
	} else {
		$category_file = join('/',array($listdir,'category_list_amod.cgi'));		// カテゴリーリストを保存するファイルのパス
	}
	// カテゴリーリストファイルが存在する場合は読み込む
	if (file_exists($category_file)) {
		list($line) = file($category_file,FILE_IGNORE_NEW_LINES);
		$tmp = explode('<>',$line);
		foreach ($tmp as $_) {
			$tmp2 = explode('<|>',$_);
			if (isset($tmp2[0])) { $cat = $tmp2[0]; } else { $cat = ''; }
			if (isset($tmp2[1])) { $nmb = $tmp2[1]; } else { $nmb = ''; }
			if ($cat) {
				$category_list[] = $cat;
				$cat_belong[$cat] = $nmb;
			}
		}
	}
	$tm_sort_list_path = join('/',array($listdir,'tm_sort_list.cgi'));
	if (file_exists($tm_sort_list_path)) {
		$tm_sort_list = array_reverse(file($tm_sort_list_path,FILE_IGNORE_NEW_LINES));
		foreach ($tm_sort_list as $line) {
			$tmp = explode('<>',$line);
			if (!$admin_mode && isset($tmp[4]) && $tmp[4]) { continue; }
			if (isset($tmp[4])) { $amod[$tmp[0]] = $tmp[4]; }
			if (isset($tmp[3]) && $tmp[3]) {
				if (strpos($tmp[3],'&&') !== false) {
					$cats = explode('&&',$tmp[3]);
					foreach ($cats as $cat) {
						if (!isset($cat_mod_tm[$cat])) { $cat_mod_tm[$cat] = '1970/01/01 00:00:00'; }
						$article_list[$cat][] = $tmp[0];
						$art_title[$tmp[0]] = $tmp[2];
						$mod_tm[$tmp[0]] = $tmp[1];
						if ($cat_mod_tm[$cat] < $tmp[1]) { $cat_mod_tm[$cat] = $tmp[1]; }
					}
				} else {
					if (!isset($cat_mod_tm[$tmp[3]])) { $cat_mod_tm[$tmp[3]] = '1970/01/01 00:00:00'; }
					$article_list[$tmp[3]][] = $tmp[0];
					$art_title[$tmp[0]] = $tmp[2];
					$mod_tm[$tmp[0]] = $tmp[1];
					if ($cat_mod_tm[$tmp[3]] < $tmp[1]) { $cat_mod_tm[$tmp[3]] = $tmp[1]; }
				}
			} else {
				if (!isset($cat_mod_tm['カテゴリーなし'])) { $cat_mod_tm['カテゴリーなし'] = '1970/01/01 00:00:00'; }
				if (!isset($cat_belong['カテゴリーなし'])) { $cat_belong['カテゴリーなし'] = 0; }
				$cat_belong['カテゴリーなし']++;
				$article_list['カテゴリーなし'][] = $tmp[0];
				$art_title[$tmp[0]] = $tmp[2];
				$mod_tm[$tmp[0]] = $tmp[1];
				if ($cat_mod_tm['カテゴリーなし'] < $tmp[1]) { $cat_mod_tm['カテゴリーなし'] = $tmp[1]; }
			}
		}
	}
	$category_list[] = 'カテゴリーなし';
	if ($option['sort'] == 'new') {
		arsort($cat_mod_tm);
		$category_list = array_keys($cat_mod_tm);
	} elseif ($option['sort'] == 'nmb') {
		arsort($cat_belong);
		$category_list = array_keys($cat_belong);
	}
	$str = '';
	$hash = array();
	if (isset($req['sort']) && $req['sort']) { $hash['sort'] = $req['sort']; }
	$cat_count = 0;
	if ($option['cat']) {
		$category_list = array($option['cat']);
	}
	if ($option['style']) {
		$style = " style=\"" . $option['style'] . "\"";
	} else {
		$style = "";
	}
	foreach ($category_list as $cat) {
		if ($option['hide_nocat'] && $cat == 'カテゴリーなし') { continue; }
		$cat_count++;
		if ($option['cat_max'] < $cat_count) { break; }
		$epc = strtotime($cat_mod_tm[$cat]);
		if ($show_new && time() - $new_day*3600*24 < $epc) {
			$new = "<span style=\"color:crimson;\">new!</span> ";
		} else {
			$new = '';
		}
		$class = 'list';
		if (req('category_filter') == $cat) {
			$hash['category_filter'] = '';
			$hash['noform'] = '';
			$link = script_link($hash);
			if ($class) { $class = " class=\"$class\""; }
			$str .= "<div$class$style>$new<a href=\"$link\">$cat(" . $cat_belong[$cat] . ")</a></div>\n";
			if (!$option['sort'] || $option['sort'] == 'name') {
				$sort = array();
				foreach ($article_list[$cat] as $key) { $sort[] = $art_title[$key]; }
				array_multisort($sort,SORT_ASC,SORT_STRING,$article_list[$cat]);
			}
			$sub = '';
			foreach ($article_list[$cat] as $id) {
				$class = 'list';
				if ($amod[$id] && $admin_mode) {
					$back_col = "background-color:$admin_back_color";
					$class = 'amode';
				} else {
					
					$back_col = '';
				}
				$epc = strtotime($mod_tm[$id]);
				if ($show_new && time() - $new_day*3600*24 < $epc) {
					$new = "<span style=\"color:crimson;\">new!</span> ";
				} else {
					$new = '';
				}
				$hash['noform'] = $id;
				$hash['category_filter'] = urlencode(req('category_filter'));
				if (req('noform') != $id && req('edit') != $id) {
					if ($class) { $class = " class=\"$class\""; }
					if (strpos($art_title[$id],'&&') !== false) {
						$art_titles = explode('&&',$art_title[$id]);
						foreach ($art_titles as $atitle) {
							$sub .= "<div$class style=\"margin-left:1em;\">$new<a href=\"" . script_link($hash) . "\">" . $atitle . "</a></div>";
						}
					} else {
						$sub .= "<div$class style=\"margin-left:1em;\">$new<a href=\"" . script_link($hash) . "\">" . $art_title[$id] . "</a></div>";
					}
				} else {
					$class = 'current';
					$class = " class=\"$class\"";
					if (strpos($art_title[$id],'&&') !== false) {
						$art_titles = explode('&&',$art_title[$id]);
						foreach ($art_titles as $atitle) {
						//	$sub .= "<div style=\"margin-left:1em;$back_col;background-color:$current_back_color\">$new" . $atitle . "</div>";
							$sub .= "<div$class style=\"margin-left:1em;\">$new" . $atitle . "</div>\n";
						}
					} else {
						$sub .= "<div$class style=\"margin-left:1em;\">$new" . $art_title[$id] . "</div>\n";
					}
				}
			}
			if ($sub) {
				//$sub = "<div style=\"margin-left:1em;\">$sub</div>\n";
				$str .= $sub;
			}
		} else {
			$hash['category_filter'] = urlencode($cat);
			$hash['noform'] = 'all';
			$link = script_link($hash);
			if ($class) { $class = " class=\"$class\""; }
			$str .= "<div$class$style>$new<a href=\"$link\">$cat(" . $cat_belong[$cat] . ")</a></div>\n";
		}
	}
	$test = "<pre>\$category_list=" . print_r($category_list,true) . "<br />\n\n";
	$test .= "\$cat_belong=" . print_r($cat_belong,true) . "<br /></pre>";
	return $str;
}


?>