<?php
$explan = "1行コメントフォームを表示
<h3>指定できるオプション</h3>
<dl><dt>order</dt><dd>フォームの表示位置
例　order=up (フォームを上に配置)　order=down (フォームを下に配置)</dd>
<dt>max_log</dt><dd>ログの保存数。これを超えると削除。
例　max_log=50</dd></dl>
";
$format = "[[comment]]	// 基本形
[[comment('down')]]	// フォームを下に配置
";


////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function comment($order = '', $max_log = '') {
	global $script, $req, $id, $id_dir, $log, $id_path;
	if (! $max_log) { $option['max_log'] = 20; }	// ログの保存数
	if (gettype($order) == 'integer') {
		$max_log = $order;
		$order = '';
	}
	if (strpos($order,'=') != false) {
		$tmp = explode('|',$order);
		$option = array();
		$order = '';
		foreach ($tmp as $_) {
			if ($_ == 'up' || $_ == 'down') {
				$option['order'] = $_;
			} else {
				$tmp2 = explode('=',$_);
				if (isset($tmp2[1])) {
					$option[$tmp2[0]] = $tmp2[1];
					if ($tmp2[0] == 'order') {
						$order = $tmp2[1];
					}
				}
			}
		}
	}
	if (!isset($option['order'])) { $option['order'] = 'up'; }	// フォームの表示位置
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	$max_log = $option['max_log'];
	$str = '';
	$id = article_id();
	if (!$id) { $id = req('id'); }
//	if (!$id) { $id = req('noform'); }
//	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (file_exists('./frontid')) {
		list($id) = file('./frontid');
	}
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'comment.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path, FILE_IGNORE_NEW_LINES);
		$last = end($log);
		$last = rtrim($last);
	}
	if (req('comment_admin')) { return comment_admin(); }
	
	if (req('posted') && req('plugin') == 'comment') {
		if (!$id) {
			error('このフォームからは投稿できません');
		} else {
			if (!is_dir($id_dir)) { mkdir($id_dir); }
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			$comment = req('comment');
			if (req('comment') && ! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
				error('ひらがなが含まれていません');
			}
			preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
			if (count($url[0]) > 2) {
				error('URLを減らしてください');
			}

			// 改行を削除
			$comment = str_replace("\r","",$comment);
			$comment = str_replace("\n","&nbsp;",$comment);
			$comment = str_replace("<","&lt;",$comment);
			$comment = str_replace(">","&gt;",$comment);
			$writer = req('writer');
			$tmp = explode('<>',$last);
			for ($i=0;$i<=2;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[2] && $tm == $tmp[0]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$writer) {
					$writer = '名無し';
				}
				$line = join('<>',array($tm,$writer,$comment)) . "\n";
				file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
			}
		}
	}
	$log = array();
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $option['max_log']) {
			$log = array_slice($log,-1*$option['max_log']);
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$str .= "<ul id=\"comment\">\n";
		if ($option['order'] == 'up') {
			$log = array_reverse($log);
		}
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			for ($i=0;$i<=2;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$str .= "<li>" . $tmp[2] . "&nbsp;-&nbsp;" . $tmp[1] . "&nbsp;-&nbsp;<span style=\"font-size:80%;\">" . $tmp[0] . "</span></li>\n";
		}
		$str .= "</ul>\n";
	}
	$hash = array('plugin'=>'comment','id'=>$id);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	$form = script_form($hash,'comment');
	$form .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">\n";
	$form .= "<div style=\"flex-basis:4em;text-align:right;\">投稿者</div>\n";
	$form .= "<div style=\"flex-basis:12em;\"><input type=\"text\" name=\"writer\" value=\"" . req('writer') . "\" style=\"width:140px;\" /></div>\n";
	$form .= "<div><input type=\"submit\" name=\"posted\" value=\"投稿\" /></div>\n";
	$form .= "</div>\n";
	$hash = array('plugin'=>'comment', 'id'=>$id, 'noform'=>req('noform'), 'sort'=>$req['sort'], 'comment_admin'=>1);
	$form .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\">\n";
	$form .= "<div style=\"flex-basis:4em;text-align:right;\"><span style=\"white-space:nowrap;\">コメント</span></div>\n";
	$form .= "<div style=\"\"><textarea name=\"comment\" cols=\"40\" rows=\"2\" style=\"width:90%;\"></textarea></div>\n";
	$form .= "<div style=\"margin-left:auto;\"><a href=\"" . script_link($hash) . "#pass$id\" style=\"font-size:80%;\">管理者用</a></div>\n";
	$form .= "</div>\n";
	$form .= "</form>\n";
	if (!$option['order'] || $option['order'] == 'down') {
		return $str . $form;
	} elseif ($option['order'] == 'up') {
		return $form . $str;
	}
}


function comment_admin() {
	global $id_dir,$str,$log,$id_path,$id,$img_ext, $req;
	$login_time = 30;
	$mes = '';
	$tmpdir = opendir($id_dir);
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^comment_admin_.+\.cgi$/',$file)) {
			if (fileatime($id_dir . '/' . $file) < time() - $login_time*60) {
				unlink($id_dir . '/' . $file);
			}
		}
	}
	closedir($tmpdir);
	$hash = array();
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^comment_admin/',$key)) { continue; }
		if (preg_match('/^(comment_|mod_|del_|pass)/',$key)) { continue; }
		$hash[$key] = req($key);
	}
	$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
	$hash['comment_admin'] = 1;
	if (req('comment_admin_login')) {
		$hash['comment_admin_login'] = req('comment_admin_login');
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash,'comment') . "\">再読み込み</a>";
	}
	if (!req('comment_admin_login')) {
		if (! req('pass')) {
			$hash = array();
			foreach (array_keys($_REQUEST) as $key) { $hash[$key] = req($key); }
			$str .= script_form($hash,'comment');
			if (isset($_COOKIE['comment_admin_pass'])) {
				$cpass = $_COOKIE['comment_admin_pass'];
			} else {
				$cpass = '';
			}
			$str .= "<input id=\"pass$id\" type=\"password\" name=\"pass\" value=\"$cpass\" size=\"12\">";
			$str .= " <input type=\"submit\" name=\"login\" value=\"ログイン\">";
			$str .= "</form>\n";
			return $str;
		} else {
			global $crypt_pass, $cookietime;
			if (decrypt(req('pass'), $crypt_pass) === 'no') {
				error("パスワードが認証できません");
			} else {
				$login_id = random_str(10);
				$comment_admin_login = $hash['comment_admin_login'] = $login_id;
				file_put_contents(join('/',array($id_dir, 'comment_admin_' . $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
				// クッキーの場合、エポック時間はどうなるのか？
				setcookie("comment_admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
				setcookie("comment_cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
			}
			$hash['pass'] = '';
		}
	} else {
		$login_path = join('/',array($id_dir, 'comment_admin_' . req('comment_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
		$lhash = array('plugin'=>'comment', 'id'=>req('id'),'noform'=>req('noform'),'sort'=>$req['sort'],'comment_admin'=>1);
		$relogin = script_link($lhash,'comment');
		if (! file_exists($login_path) ) {
			error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
		} else {
			if (filemtime($login_path) + 60 * $login_time < time()) {
				unlink($login_path);
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
			} else {
				file_put_contents($login_path,'',LOCK_EX);
			}
		}
	}
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^del_(\w+$)/',$key,$match)) {
			$del_id = $match[1];
			$new_log = array();
			$tmp_log = array_reverse($log);
			$mes .= '<div><strong>[' . str_replace('<>', '  ', $tmp_log[$del_id - 1]) . ']</strong> の記事を削除しました。</div>';
			unset($tmp_log[$del_id - 1]);
			$log = array_reverse($tmp_log);
			file_put_contents($id_path, join("\n", $log), LOCK_EX);
			break;
		}
	}
	if (!isset($comment_admin_login) || !$comment_admin_login) { $comment_admin_login = req('comment_admin_login'); }
	$hash = array('plugin'=>'comment', 'id'=>$id, 'comment_admin'=>1, 'comment_admin_login'=>$comment_admin_login);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	$indx = '';
	$str .= "<div style=\"color:crimson\">$mes</div>\n";
	$hash['show_spam'] = 0;
	$hash['comment_admin'] = 1;
	$hash['edit_ng'] = 0;
	if (req('comment_admin_login')) { $hash['comment_admin_login'] = req('comment_admin_login'); }
	$str .= script_form($hash);
	$str .= "<div>\n";
	$hash['comment_admin'] = 1;
	$count = 0;
	foreach (array_reverse($log) as $line) {
		$count++;
		list($date, $name, $comment) = explode('<>', $line);
		if ($count % 2) {
			$backcol = "background-color:#dddddd;";
		} else {
			$backcol = "";
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:flex-start;padding:0.2em;$backcol\">";
		$str .= "<div style=\"padding:0.2em;\"><span style=\"font-size:80%;\">$date</span></div>";
		$str .= "<div style=\"padding:0.2em;flex-basis:7em;\">$name</div>";
		$str .= "<div style=\"padding:0.2em;\">$comment</div>";
		$hash['del_' . $count] = 1;
		$str .= "<div style=\"padding:0.2em;margin-left:auto;\"><input type=\"submit\" name=\"del_" . $count . "\" value=\"削除\" style=\"font-size:80%;\"></div>";
		$str .= "</div>\n";
	}
	$str .= "</div>\n";
	$str .= "</form>\n";
	$str = str_replace("\n","|n|",$str);
	return $str;
}

?>