<?php
$explan = "プラグインの一覧と説明、使用例を表示する。
説明は\$explan、使用例は\$formatで指定する。
<pre>[[plugins]]</pre>と記述する。
<pre>[[plugins('keyword=プラグイン')]]</pre>のように引数を入れると、検索して該当するプラグインのみ表示する。
正規表現も使用できる。
";

function plugins($option = '') {
	global $script;
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			if (strpos($_, '=') > 0) {
				$tmp2 = explode('=',$_);
				if (isset($tmp2[0]) && isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
			} else {
				$keyword = $_;
			}
		}
	} else {
		unset($option);
	}
	if (! isset($option['keyword'])) { $option['keyword'] = ''; }
	if (! isset($option['term_area'])) { $option['term_area'] = ''; }
	if (!isset($keyword)) { $keyword = $option['keyword']; }
	$str = '';
	if (!$keyword) { $str .= "<div>インストールされているプラグインの一覧です。</div>\n"; }
	$str = str_replace("\n","<br />\n",$str);
	$files = scandir('./plugin');
	$count = 0;
	$ini_list = array();
	$name_list = array();
	foreach ($files as $file) {
		if (!is_file(join('/',array('./plugin',$file)))) { $count++;	continue; }
		if (preg_match('/^\.{1,2}$/',$file)) {
			unset($files[$count]);
		} elseif ($keyword && preg_match('/^\/.+\/$/',$keyword) && !preg_match($keyword,$file)) {
			unset($files[$count]);
		} elseif ($keyword && !preg_match('/^\/.+\/$/',$keyword) && strpos($file,$keyword) === false) {
			unset($files[$count]);
		} else {
			$explan = '';
			$format = '';
			require_once join('/',array('./plugin',$file));
			if (!$explan || !$format) {
				$cont = file(join('/',array('./plugin',$file)));
				$new_cont = array();
				foreach ($cont as $line) {
					if (preg_match('/function\s+.+\(/',$line)) {
						break;
					} else {
						$new_cont[] = $line;
					}
				}
				$cont = $new_cont;
			}
			if (!$explan) {
				$ptn1 = '/explan\s*?=\s*?"([\s\S]+?)"/';
				$ptn2 = "/explan\s*?=\s*?'([\s\S]+?)'/";
				foreach (array($ptn1,$ptn2) as $ptn) {
					if (preg_match($ptn,join('',$cont),$matched)) {
						if (isset($matched[1])) {
							$explan = $matched[1];
							break;
						}
					}
				}
			}
			if (!$format) {
				$ptn1 = '/format\s*?=\s*?"([\s\S]+?)"/';
				$ptn2 = "/format\s*?=\s*?'([\s\S]+?)'/";
				foreach (array($ptn1,$ptn2) as $ptn) {
					if (preg_match($ptn,join('',$cont),$matched)) {
						if (isset($matched[1])) {
							$format = $matched[1];
							break;
						}
					}
				}
			}
			if (isset($explan)) {
				$exp[$count] = $explan;
			} else {
				$exp[$count] = '説明なし';
			}
			if (isset($format)) {
				$form[$count] = $format;
			} else {
				$form[$count] = '';
			}
			$name = preg_replace('/\.php$/','',$file);
			
			if (preg_match("/^[a-zA-Z]/", $name)) {
				$ini = strtoupper(mb_substr($name,0,1));
			} else if (preg_match("/^\d/", $name)) {
				$ini = mb_substr($name,0,1);
				$ini = '数';
			} else {
				$ini = mb_substr($name,0,1) . '-';
			}
			if (! isset($name_list[$ini])) {
				$name_list[$ini] = '';
			}
			$ex = strip_tags($exp[$count]);
			$ex = preg_split('/\s+/',$ex);
			$hash = array('show_plg'=>$name);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$link = script_link($hash);
			$name_list[$ini] .= "<dl><dt><a class=\"pup\" href=\"$link#plugin_$name\">" . $name . "</a></dt><dd>" . $ex[0] . "</dd></dl>\n!$name!";
		}
		$count++;
	}
	foreach (array_keys($name_list) as $ini) {
		$str .= '<strong>[' . $ini . ']</strong>' . $name_list[$ini];
	}
	$str2 = '';
	foreach ($files as $key=>$val) {
		$name = preg_replace('/\.php$/','',$val);
		if (req('show_plg') != $name && req('plugin') != $name) {
			$str = str_replace('!' . $name . '!', '', $str);
			continue;
		}
		$pname = $name;
		$str2 .= "<h1><a name=\"plugin_$name\" id=\"plugin_$name\">" . $name . "</a></h1>";
		if (isset($exp[$key])) {
			$exp[$key] = str_replace(">\n",">",$exp[$key]);
			$exp[$key] = str_replace("\n","<br />\n",$exp[$key]);
			$str2 .= $exp[$key];
		}
		if (isset($form[$key]) && $form[$key]) {
			$form[$key] = rtrim($form[$key]);
			$frm = explode("\n",$form[$key]);
			$str2 .= "<h2>使用例</h2>";
			foreach ($frm as $_) {
				if (!$_) { continue; }
				// <pre>タグだと長い行が枠からはみ出す場合があるので、＜div＞タグに変更
				$str2 .= "<pre style=\"background-color:#ddeeff;padding:0.5em;border-radius:8px;margin-top:1em;margin-bottom:1em;\">";
				$str2 .= $_ . "\n";
				$str2 .= "</pre>";
				preg_match('/\[\[([^]]+)\]\]?/',$_,$matched);
				if ($matched) {
					
					$op = '';
					if (preg_match('/\((.*)\)$/', $matched[1], $match)) {
						$op = preg_replace("/^'(.*)'$/", '$1', $match[1]);
						$tmp = explode('|', $op);
						if ($option['term_area']) { $tmp[] = "term_area=" . $option['term_area']; }
						$op = join('|', $tmp);
						
					} else {
						if ($option['term_area']) { $op = "term_area=" . $option['term_area']; }
					}
					$matched[1] = $pname . "('$op')";
					$code = '$tmp = ' . $matched[1];
					if (!preg_match('/;\s?$/',$code)) { $code .= ';'; }
					if (!preg_match('/\(.*\);\s?$/',$code)) { $code = preg_replace('/;\s?$/','();',$code); }
					try {
						eval ($code);
					} catch(Exception $e) {
						$str2 .= 'プラグインの実行に失敗';
					}
					if (is_array($tmp)) {
						$str2 .= join('',$tmp);
					} else {
						$str2 .= $tmp;
					}
				}
			}
		}
	}
	if (isset($pname) && $pname) { $str = str_replace('!' . $pname . '!', "<div>" . $str2 . "<hr style=\"margin-bottom:1em;\">\n</div>\n", $str); }
	$str = str_replace(array("\r\n","\r","\n"), '|n|', $str);
	return $str;
}
?>